
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何加快C++代码的编译速度 / iVAN</title>

    <meta name="description" content="如何加快C++代码的编译速度   C++代码一直以其运行时的高性能高调面对世人, 但是说起编译速度,却只有低调的份了.比如我现在工作的源代码,哪怕使用Incredibuild调动近百台机子,一个完整的build也需要四个小时,恐怖!!!虽然平时开发一般不需要在本地做完整的build,但编译几个相关的工程就够你等上好一段时间的了(老外管这个叫monkey around,相当形象).想想若干年在一台单核2.8GHZ上工作时的场景 - 面前放本书,一点build按钮,就低头读一会书~~~往事不堪回首. 可以想象,如果不加以重视,编">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">如何加快C++代码的编译速度</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> 　　C++代码一直以其运行时的高性能高调面对世人，  但是说起编译速度，却只有低调的份了。比如我现在工作的源代码，哪怕使用Incredibuild调动近百台机子，一个完整的build也需要四个小时，恐怖!!!虽然平时开发一般不需要在本地做完整的build，但编译几个相关的工程就够你等上好一段时间的了(老外管这个叫monkey  around，相当形象)。想想若干年在一台单核2.8GHZ上工作时的场景 - 面前放本书，一点build按钮，就低头读一会书~~~往事不堪回首。</p>
<p>　　可以想象，如果不加以重视，编译速度极有可能会成为开发过程中的一个瓶颈。那么，为什么C++它就编译的这么慢呢?</p>
<p>　　我想最重要的一个原因应该是C++基本的"头文件-源文件"的编译模型：</p>
<p>　　每个源文件作为一个编译单元，可能会包含上百甚至上千个头文件，而在每一个编译单元，这些头文件都会被从硬盘读进来一遍，然后被解析一遍。</p>
<p>　　每个编译单元都会产生一个obj文件，然后所以这些obj文件会被link到一起，并且这个过程很难并行。</p>
<p>　　这里，问题在于无数头文件的重复load与解析，以及密集的磁盘操作。</p>
<p>　　下面从各个角度给出一些加快编译速度的做法，主要还是针对上面提出的这个关键问题。</p>
<p>　　一、代码角度</p>
<p>　　在头文件中使用前置声明，而不是直接包含头文件。</p>
<p>　　不要以为你只是多加了一个头文件，由于头文件的"被包含"特性，这种效果可能会被无限放大。所以，要尽一切可能使头文件精简。很多时候前置申明某个namespace中的类会比较痛苦，而直接include会方便很多，千万要抵制住这种诱惑;类的成员，函数参数等也尽量用引用，指针，为前置声明创造条件。</p>
<p>　　使用Pimpl模式</p>
<p>　　Pimpl全称为Private  Implementation。传统的C++的类的接口与实现是混淆在一起的，而Pimpl这种做法使得类的接口与实现得以完全分离。如此，只要类的公共接口保持不变，对类实现的修改始终只需编译该cpp;同时，该类提供给外界的头文件也会精简许多。</p>
<p>　　高度模块化</p>
<p>　　模块化就是低耦合，就是尽可能的减少相互依赖。这里其实有两个层面的意思。一是文件与文件之间，一个头文件的变化，尽量不要引起其他文件的重新编译;二是工程与工程之间，对一个工程的修改，尽量不要引起太多其他工程的编译。这就要求头文件，或者工程的内容一定要单一，不要什么东西都往里面塞，从而引起不必要的依赖。这也可以说是内聚性吧。</p>
<p>　　以头文件为例，不要把两个不相关的类，或者没什么联系的宏定义放到一个头文件里。内容要尽量单一，从而不会使包含他们的文件包含了不需要的内容。记得我们曾经做过这么一个事，把代码中最"hot"的那些头文件找出来，然后分成多个独立的小文件，效果相当可观。</p>
<p>　　其实我们去年做过的refactoring，把众多DLL分离成UI与Core两个部分，也是有着相同的效果的 - 提高开发效率。</p>
<p>　　删除冗余的头文件</p>
<p>　　一些代码经过上十年的开发与维护，经手的人无数，很有可能出现包含了没用的头文件，或重复包含的现象，去掉这些冗余的include是相当必要的。当然，这主要是针对cpp的，因为对于一个头文件，其中的某个include是否冗余很难界定，得看是否在最终的编译单元中用到了，而这样又可能出现在一个编译单元用到了，而在另外一个编译单元中没用到的情况。</p>
<p>　　之前曾写过一个Perl脚本用来自动去除这些冗余的头文件，在某个工程中竟然去掉多达了5000多个的include。</p>
<p>　　特别注意inline和template</p>
<p>　　这是C++中两种比较"先进"的机制，但是它们却又强制我们在头文件中包含实现，这对增加头文件的内容，从而减慢编译速度有着很大的贡献。使用之前，权衡一下。</p>
<p>　　二、综合技巧</p>
<p>　　预编译头文件(PCH)</p>
<p>　　把一些常用但不常改动的头文件放在预编译头文件中。这样，至少在单个工程中你不需要在每个编译单元里一遍又一遍的load与解析同一个头文件了。</p>
<p>　　Unity Build</p>
<p>　　Unity Build做法很简单，把所有的cpp包含到一个cpp中(all.cpp)  ,然后只编译all.cpp。这样我们就只有一个编译单元，这意味着不需要重复load与解析同一个头文件了，同时因为只产生一个obj文件，在链接的时候也不需要那么密集的磁盘操作了,估计能有10x的提高，看看这个视频感受一下其做法与速度吧。</p>
<p>　　ccache</p>
<p>　　compiler cache,  通过cache上一次编译的结果，使rebuild在保持结果相同的情况下，极大的提高速度。我们知道如果是build，系统会对比源代码与目标代码的时间来决定是否要重新编译某个文件，这个方法其实并不完全可靠(比如从svn上拿了上个版本的代码)，而ccache判断的原则则是文件的内容，相对来讲要可靠的多。很可惜的是，Visual  Studio现在还不支持这个功能 - 其实完全可以加一个新的命令，比如cache  build，介于build与rebuild之间，这样，rebuild就可以基本不用了。</p>
<p>　　不要有太多的Additional Include Directories</p>
<p>　　编译器定位你include的头文件，是根据你提供的include  directories进行搜索的。可以想象，如果你提供了100个包含目录，而某个头文件是在第100个目录下，定位它的过程是非常痛苦的。组织好你的包含目录，并尽量保持简洁。</p>
<p>　　三、编译资源</p>
<p>　　要提高速度，要么减少任务，要么加派人手，前面两个方面讲得都是减少任务，而事实上，在提高编译速度这块，加派人手还是有着非常重要的作用的。</p>
<p>　　并行编译</p>
<p>　　买个4核的，或者8核的cpu，每次一build，就是8个文件并行着编，那速度，看着都爽。 要是你们老板不同意，让他读读这篇文章：Hardware is  Cheap, Programmers are Expensive</p>
<p>　　更好的磁盘</p>
<p>　　我们知道，编译速度慢很大一部分原因是磁盘操作，那么除了尽可能的减少磁盘操作，我们还可以做的就是加快磁盘速度。比如上面8个核一块工作的时候，磁盘极有可能成为最大的瓶颈。买个15000转的磁盘，或者SSD，或者RAID0的，总之，越快越好。</p>
<p>　　分布式编译</p>
<p>　　一台机子的性能始终是有限的，利用网络中空闲的cpu资源，以及专门用来编译的build  server来帮助你编译才能从根本上解决我们编译速度的问题，想想原来要build 1个多小时工程的在2分钟内就能搞定，你就知道你一定不能没有它 -  Incredibuild并行，其实还可以这么做。</p>
<p>　　这是一个比较极端的情况，如果你用了Incredibuild，对最终的编译速度还是不满意，怎么办?其实只要跳出思维的框架，编译速度还是可以有质的飞跃的  - 前提是你有足够多的机器：</p>
<p>　　假设你有solution A和solution B，B依赖于A，所以必须在A之后Build B。其中A，B  Build各需要1个小时，那么总共要2个小时。可是B一定要在A之后build吗?跳出这个思维框架，你就有了下述方案：</p>
<p>　　同时开始build A和B 。</p>
<p>　　A的build成功，这里虽然B的build失败了，但都只是失败在最后的link上。</p>
<p>　　重新link B中的project。</p>
<p>　　这样，通过让A的build与B的编译并行，最后link一下B中的project，整个编译速度应该能够控制在1个小时15分钟之内。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-16 13:43:23</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e9%80%9f%e5%ba%a6/" title="速度">速度</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e8%af%91/" title="编译">编译</a>, <a href="https://www.iamivan.net/tag/%e5%a4%b4%e6%96%87%e4%bb%b6/" title="头文件">头文件</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e8%af%91%e9%80%9f%e5%ba%a6/" title="编译速度">编译速度</a>, <a href="https://www.iamivan.net/tag/build/" title="build">build</a>, <a href="https://www.iamivan.net/tag/perl%e5%b9%b6%e8%a1%8c/" title="perl并行">perl并行</a>, <a href="https://www.iamivan.net/tag/%e5%a4%b4%e6%96%87%e4%bb%b6%e5%8c%85%e5%90%ab/" title="头文件包含">头文件包含</a>, <a href="https://www.iamivan.net/tag/c-%e5%a4%b4%e6%96%87%e4%bb%b6/" title="c&plus;&plus;头文件">c&plus;&plus;头文件</a>, <a href="https://www.iamivan.net/tag/jsonrpc-cpp%e5%bc%80%e5%8f%91%e9%97%ae%e9%a2%98/" title="jsonrpc cpp开发问题">jsonrpc cpp开发问题</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>如何加快C++代码的编译速度的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmvEWb.html" rel="bookmark">Kotlin VS Java：编译速度大比拼，到底谁更快？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				把一个Java应用程序转换为Kotlin,编译时间要多久? 这是关于Kotlin的一系列文章.分为三个部分. 第一部分讨论了从Java转换到Kotlin.第二部分是我对Kotlin的看法. 在前面的文章中, 我讨论了把Android 应用从Java 100%转换为Kotlin . Kotlin代码比Java的简洁,更易于维护,所以我认为转换是值得的. 但有些人不想试用Kotlin,因为他们担心它编译可能没有Java快. 这个关注点绝对是正确的,如果变得编译很慢,没有人愿意转换他们的代码. 所以,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZGmdb.html" rel="bookmark">如何将iOS项目的编译速度提高5倍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 贝聊目前开发的两款App分别是贝聊家长版和贝聊老师版,最近因为在快速迭代开发新功能,项目规模急速增长,单个端业务代码约23万行,私有库约6万行,第三方库代码约15万行,单个客户端的代码行数约60万.现在打包一次耗时需要11~12分钟.虽然还远远比不上 Facebook 的40分钟,但是我们在内测的时候,经常一天要发布内测版两到三次.打包时CPU占用基本上是百分百的,因为没有专门的 CI 机器,对负责打包的同事(其实就是我自己)的工作时间占用比较多,所以最近一直在寻找加快打包速度的方案. 目			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrvB3VM.html" rel="bookmark">XCode编译速度慢的处理方法&lowbar;IOS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				提升编译链接的速度主要有以下三个方式: 1. 提高XCode编译时使用的线程数 复制代码 代码如下: defaults write com.apple.Xcode PBXNumberOfParallelBuildSubtasks 4 XCode默认使用与CPU核数相同的线程来进行编译,但由于编译过程中的IO操作往往比CPU运算要多,因此适当的提升线程数可以在一定程度上加快编译速度. 2. 将Debug Information Format改为DWARF 在工程对应Target的Build Set			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnxOnWb.html" rel="bookmark">通过预编译头文件来提高CB的编译速度</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C++ Builder是最快的C++编译器之一,从编译速度来说也可以说是最快的win32C++编译器了.除了速度之外,C++builder的性能也在其它C++编译器的之上,但许多delphi程序员仍受不了C++builder工程的编译速度.的确,delphi的速度要比任和c++的编译器都要快好多.Delphi在编译一个小工程的时候可能不到一秒,大的工程一般也在5秒钟这内编译完成了. 为什么delphi会比c++builder快这么多?是否有方法来c++builder的编译速度?本文就讲解了为什么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk2gXrM.html" rel="bookmark">C&num;代码动态编译、动态执行、动态调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几天看到一篇关于.net动态编译的文章 .NET中的动态编译 ,很受启发.在 此基础上我做了一些封装,为使调用更加简单,并增加了对动态代码调试的支持 ,相同代码只编译一次的支持,代码改动自动重新编译,代码引用文件的自动加 载和手工加载等功能. 如上图,我封装的类CSharpProvider很简单,下面说明一下一些公共成员 的用法. 公共属性 AssemblyFileName:这个属性指定动态编译后 生成的配件名称. CompilerParameters:这个属性指定编译的参数 Referenc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9ERVdM.html" rel="bookmark">加快win7系统搜索文件速度的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于一些文件大户,比如你是制版的,设计的,排版的那么你的电脑中一定有非常非常多的文件,由于文件太多我们不可能完全记住文件存放在什么地方这时候大家经常使用的就是win7系统的文件搜索功能了,不过有的朋友不满意win7系统搜索文件的速度,我们可以通过一些搜索设置来加快搜索文件的快速性. 在搜索设置中,我们主要通过清除一些无用的引索来达到加快搜索速度的目的,下面看操作方法: 第一步:右击任务栏--选择属性,在开始菜单设置界面,点缶自定义按钮; 第二步. 在&quot;自定义'开始'菜单&quot;窗口,拖动上方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6AL3M.html" rel="bookmark">c&num;-C&num;能不能构造B树，加快海量文件的查询速度？请问如何用C&num;构造B树呢？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C#能不能构造B树,加快海量文件的查询速度?请问如何用C#构造B树呢? C#能不能构造B树,加快海量文件的查询速度?请问如何用C#构造B树呢? 解决方案 http://www.cnblogs.com/CareySon/archive/2012/04/06/Imple-BTree-With-CSharp.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQ9ROp.html" rel="bookmark">为什么需要标示符，求大神。在第三行代码，编译时出错。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 为什么需要标示符,求大神.在第三行代码,编译时出错. class Point{ double x,y,z; Point(double_x,double_y,double_z ) { x=_x; y=_y; z=_z; } void setX(double _x){ x=_x; } void setY(double _y){ y=_y; } void setZ(double_z){ z=_z; } double getDistance(Point P){ return(x-p.x)*(x			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmZX0z.html" rel="bookmark">struct-这个代码在编译时没有错误，在运行时却弹出debug assertion failed line52</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 这个代码在编译时没有错误,在运行时却弹出debug assertion failed line52 #ifndef Linkstack_H #define Linkstack_H #include using namespace std; template struct Node { T data; Nodenext; }; template class LinkStack { public: LinkStack();//{top=NULL;} ~LinkStack(); void P			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9AakM.html" rel="bookmark" class="title">分析网站结构在seo中发挥的巨大作用</a>
					<div>
						网站结构按照性质可以分为逻辑结构和物理结构,是网站中页面之间层次关系的体现. 从seo的角度来看,网站结构优化是不可忽略的一个重要环节,其效果与网站收录和权重息息相关.在这个内容为王外链为皇的时代,网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnnBop.html" rel="bookmark" class="title">XmlReader 读取器读取内存流 MemoryStream 的注意事项</a>
					<div>
						stream|xml MemoryStream对象提供了无需进行IO就可以创建Stream的方法,XmlTextWriter和XmlReader提供快速书写和读取XML内容的方法,结合MemorySt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrK36Op.html" rel="bookmark" class="title">数据仓库集成设备选型指导</a>
					<div>
						选择合适的数据仓库技术从来都不简单.无论是传统的企业数据仓库软件还是 目前非常流行的数据仓库集成设备,如何选择合适的方案来满足企业的业务需求 是每一位管理者都要面对的,这其中不仅涉及到一些步骤和注意事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AYEnp.html" rel="bookmark" class="title">教你玩新招：在Office中秀出动画</a>
					<div>
						小时候,我们痴迷地翻看一本本的小人书,后来,我们坐在电视机前津津有味地欣赏动画片--有了声音和动起来的画面,生活无比美妙.现在,用电脑看Flash成为家常便饭,我们却习惯于每天面对&quot;静止&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1eeAz.html" rel="bookmark" class="title">word如何在插入的图形中书写文字&quest;</a>
					<div>
						  word如何在插入的图形中书写文字? 1.打开WORD 方法一:点击菜单里面的[插入]找到[图片],选择[自选图形] 方法二:直接点击页面中的[自选图形] 选择自己需要的图形,然后在页面中点击,并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Axymp.html" rel="bookmark" class="title">用iSee图片专家--制作网店店招</a>
					<div>
						网店装修最最重要的部分就是制作店招.买家一进店铺,首先看到的就是店招.如何制作出醒目又个性的店招,是每个刚开店的卖家最需要考虑的. iSee现在教大家制作醒目的网店店招.(淘宝网对店招的限制:文件格式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEl193z.html" rel="bookmark" class="title">win7防火墙打开显示错误代码0x80070422怎么办</a>
					<div>
						  win7系统防火墙打开显示错误代码0x80070422怎么办,这是什么情况呢? 一.首先打开运行窗口,输入services.msc回车进入服务窗口. 二.接着在服务窗口中找到windows fir ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwwnxp.html" rel="bookmark" class="title">XP系统找不到音量控制程序怎么办</a>
					<div>
						  XP系统找不到音量控制程序怎么办          (1)音量控制程序还在: 1.打开控制面板 2.点击添加/删除程序 3.点击添加删除windows组件 4.打开附件选项 5.选中&quot;多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArrZZp.html" rel="bookmark" class="title">甲方如何与设计师明确需求？</a>
					<div>
						  甲方虐我千百遍,我待甲方如初恋.相信设计师们都有过遇到奇葩甲方的经历,那么下一次遇到时,请你狠狠地拿出这篇文章,告诉他怎么成为一个合格的甲方. 如果你就是甲方,仔细阅读来自两位资深前辈的衷心建议, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXj0eLb.html" rel="bookmark" class="title">word表格不为人知的五则另类技巧</a>
					<div>
						今天总结了一些Word中的阿拉伯数字小技巧供大家参考. 技巧一:将阿拉伯数字转换成大写数字 年终财务总结中的一些数字,按国人的习惯,通常用大写的格式表示,直接输入大写字符吧,比较麻烦.其实,我们可以用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWwQ0b.html" rel="bookmark" class="title">win7系统的命令提示符功能被禁用掉了怎么办</a>
					<div>
						  1.首先,咱们同时按下win7旗舰版电脑键盘上的win+R快捷键打开电脑的运行窗口,在打开的运行窗口中,咱们输入gpedit.msc并单击回车,这样就可以打开win7旗舰版系统的组策略编辑器窗口了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaoGqM.html" rel="bookmark" class="title">365日历怎么用</a>
					<div>
						  查阅日历 在翻阅的过程中,可以查看当天的日历或者是当月当年的日历,在查阅的时候,下面会有关于今天是什么日子的一个解释. 特殊日期设置 点一下设置,里面会出现特殊日期的设置,包括生日,节日,生理期等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwK3AM.html" rel="bookmark" class="title">wxWidgets初学者导引（6）&mdash;&mdash;wxWidgets学习材料清单</a>
					<div>
						wxWidgets初学者导引全目录   PDF版及附件下载 1 前言2 下载.安装wxWidgets3 wxWidgets应用程序初体验4 wxWidgets学习资料及利用方法指导5 用wxSmith ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NrwWz.html" rel="bookmark" class="title">产品经理在运营人员眼中是怎样的人？</a>
					<div>
						我曾经以为产品经理应该是这样的: 我想说的是,产品经理,觉悟吧!!!事实上却是这样的: 看了之前那么多的IT圈里的高手在阐述关于&quot;产品经理&quot;这个话题,让我站在这即将开启全行业转型产 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Nd96z.html" rel="bookmark" class="title">急！-idea14 maven projects dependencies出现波浪线，导入不到项目中</a>
					<div>
						问题描述 idea14 maven projects dependencies出现波浪线,导入不到项目中 解决方案 idea 14创建maven项目(一)IntelliJ IDEA14 导入 mave ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW6Y6p.html" rel="bookmark" class="title">泉州论坛升级Discuz&excl; 7&period;2版本期待UltraX</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 最新消息,泉州地区知名社区泉州论坛(http://www.qzbbs.com)日前成功升级.泉州论坛通过采用康盛创想(Comsenz)旗下最新产品Dis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAjLDp.html" rel="bookmark" class="title">应用-vb中用代码如何将com&plus;组件卸载？</a>
					<div>
						问题描述 vb中用代码如何将com+组件卸载? '函数名称:DeleteComponent'作用:删除对应com+应用中的组件'参数:sFolder COM+目录,sFileName组件名Public ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RZrVb.html" rel="bookmark" class="title">云端App开发：如何在容器中运行JBoss BRMS</a>
					<div>
						本文讲的是云端App开发:如何在容器中运行JBoss BRMS[编者的话]本文介绍了在Red Hat上安装容器化JBoss BRMS的步骤,是系列文章中的一部分,建议浏览文章中的相关链接介绍. 本文中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZg7Vqb.html" rel="bookmark" class="title">完全免费 云操作系统Cloudo任你游</a>
					<div>
						如果你在办公室里留下来一些工作未完成,如果在http://www.aliyun.com/zixun/aggregation/14211.html&quot;&gt;图书管理里看到一些特别需要的资料,甚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYwxAp.html" rel="bookmark" class="title">方法-C&num;  并非所有的代码路径都返回值</a>
					<div>
						问题描述 C# 并非所有的代码路径都返回值 public static string aa(string a) { if (a == &quot;&quot;) { MessageBox.Show(& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXk35b.html" rel="bookmark" class="title">转一篇：文档笔记之Django QuerySet</a>
					<div>
						这个放着,说不定以后作一些更深入的查询时,用得着的.   http://www.rapospectre.com/blog/7/ 今天刚刚答完辩体完检就跑来更新博客了!!! 先补上第一篇: 一般情况下, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22QQvb.html" rel="bookmark" class="title">linux内核-linux安装mysql问题~~~~~</a>
					<div>
						问题描述 linux安装mysql问题~~~~~ 有root权限 #rpm -ivh mysql-server-5.6.13.i386.rpm 然后就出现这些 Preparing... ####### ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEoZmp.html" rel="bookmark" class="title">我所理解的Android 启动模式</a>
					<div>
						首先,这是从 一个开源网站转载的,觉得写得不错,对我们之前理解的activity的启动模式是一个新的理解方式,并给出实际的应用场景. 任务栈是什么 任务栈Task,是一种用来放置Activity实例的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1BPWb.html" rel="bookmark" class="title">Visual Style中的shellstyle&period;dll文件修改方法&lowbar;应用技巧</a>
					<div>
						Visual Style中的shellstyle.dll文件修改  2007-3-8 11:25:00  作者: Silencer  shellstyle.dll修改 *部分内容参考自whistl3r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QZx5M.html" rel="bookmark" class="title">Illustrator简单打造漂亮凹凸感背景制作教程</a>
					<div>
						给各位Illustrator软件的使用者们来详细的解析分享一下简单打造漂亮凹凸感背景的制作教程. 教程分享: 先来看看最终效果图吧:   方法很多,这里我只说一种我的做法: 1.首先绘制以下图形,矩形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvLaxM.html" rel="bookmark" class="title">实例详解Android文件存储数据方式&lowbar;Android</a>
					<div>
						总体的来讲,数据存储方式有三种:一个是文件,一个是数据库,另一个则是网络.下面通过本文给大家介绍Android文件存储数据方式. 1.文件存储数据使用了Java中的IO操作来进行文件的保存和读取,只不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5V8Wz.html" rel="bookmark" class="title">在Windows 9系统上&comma;微软面临的四个艰巨挑战是什么呢</a>
					<div>
						下一代操作系统最终命名很有可能为Windows 9?是真的么?微软对外披露代号为&quot;Threshold&quot;的下一代Windows信息,其预览版也将会在公开后不久提供给公众试用. 根据消 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1548b.html" rel="bookmark" class="title">为什么说java中private内部类上转型为接口后可以隐藏内部类的实现？</a>
					<div>
						问题描述 为什么说java中private内部类上转型为接口后可以隐藏内部类的实现? 学习java中 看到类的高级特性关于内部成员类这一章 出现这么一句话把我拦住鸟 读不太明白 还请大神解释一下 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2on6z.html" rel="bookmark" class="title">构造函数-context里面有什么的内容</a>
					<div>
						问题描述 context里面有什么的内容 在StudentDao类文件中代码如下: public class StudentDao { Context context; final String ta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8vyob.html" rel="bookmark" class="title">&period;NET 大虾进来帮帮忙哦！～</a>
					<div>
						问题描述 我现在用.NET做一个软件,有个问题,就是我点击一个按钮就把邮件直接发送出去,不用启动OutLook.是不是有这样的组件!谢谢大哥们帮一下忙了!有什么方法告诉我呀!要是有什么组件就发到我的邮 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
